===========
reStructWeb
===========


reStructWeb est un petit programme en langage Python_ que j'ai écrit pour gérer
mon site Web personnel. Les fonctions principales que je souhaitai lorsque j'ai
décidé de le faire sont :

* Pouvoir modifier mon site simplement et en ligne.
* Ne pas avoir à écrire mes pages en html ou en xml
* Avoir un système de liens entre les pages très simple (comme les Wiki_)
* Intégrer un système de template et css pour séparer la présentation du contenu
* Être multi-langue
* Être performant et léger pour mon pauvre serveur (Apropos_).

Je me suis inspiré du système Wiki_ pour mettre à jour mon site Web.
Les pages sont créées en format texte via le format reStructuredText_.
Regardez par exemple la source de ce document en cliquant sur le lien
*Source* en bas de la page.


----------------

.. contents::

----------------

Outils nécessaires
==================

reStructWeb est basé sur les outils suivants :

* Python_
* Docutils_
* Apache_

A l'heure actuelle reStructWeb fait à peine plus de 300 lignes de code.
Le plus gros du travail (la gestion du format reStructuredText_) est fait par
Docutils_

reStructWeb a été testé sur les environnements suivants :

* Red Hat 9
* Red Hat 8
* Debian Sarge
* Python_ 2.2.2, 2.2.3, 2.3.3
* apache_ 2.0.40 
* docutils_ snapshot téléchargé le 2 mai 2004

Le programme devrait fonctionner sur n'importe quel système supportant
Python_ 2.2 (ou plus) et docutils_.

Principe et performances
========================

Le système utilisé est très performant. La majorité du temps, les pages sont
envoyées au navigateur directement par Apache (pages statiques). Deux cas de figures vont amener Apache à renvoyer la requête sur le script reStructWeb :

1. L'URL demandée n'existe pas
2. L'URL demandée contient des paramètres

Le script va proposer de créer une page si elle n'existe pas ou proposer
la modification d'une page existante. Elle génère par la suite les pages
html dans les différentes langues et Apache pourra les envoyer de manière
traditionnelle.

Apache_ nécessite une petite configuration pour renvoyer les requêtes vers
reStructWeb. On peut toutefois fonctionner utiliser reStructWeb de manière
traditionnelle comme un cgi, par exemple :

Avec configuration d'Apache : ::

 http://www.test.com/index.html.fr

Sans configuration d'Apache : ::

 http://www.test.com/rstweb.cgi/index.html.fr


Ce que reStructWeb n'est pas
============================

reStructWeb est juste un petit programme que j'ai écrit pour mes besoins
uniquement. Il n'a pas été pensé et n'est pas du tout adapté à un système
devant être géré par plusieurs personnes. Il n'y a pas de gestion 
d'utilisateurs, pas d'historiques de modifications et les options de
sécurité sont  inexistantes : La permission de modification du site est basé
sur un unique mot de passe, le magicWord :-)

.. CAUTION::

   Ne laissez pas des utilisateurs anonymes modifier le contenu de votre site.
   reStructWeb n'est **pas** un Wiki. Un utilisateur mal-attentionné peut
   détourner l'utilisation du reStructuredText pour tenter de compromettre
   le système. Exemple : ::

   .. include:: /etc/passwd 

   Il est ainsi possible d'inclure le contenu dans la page de n'importe quel
   fichier sur le serveur (pour lequel l'utilisateur d'apache à les droits de
   lecture).


Ceci dit, il est très rapide [#]_ , très léger, très simple à mettre en
oeuvre (un unique fichier et quatre paramètres)

.. [#] Ce n'est pas le script reStructWeb qui est rapide, mais l'envoi
       par Apache de pages statiques. Ce qui est pratiquement toujours le cas
       sur mon site.


Téléchargement
==============

* Version 0.1 : download_

.. _download: st/files/reStructWeb-0.1.tar.gz 

Configuration
=============

Mode standalone
---------------

Dans ce mode, il n'y a rien à configurer au niveau d'apache, il
suffit de copier le script dans le répertoire ``cgi-bin``.

1. Installer docutils_, Télécharger reStructWeb
2. Copier le fichier ``rstgen.py`` dans le répertoire ``cgi-bin``
3. Modifier si besoin les paramètres dans ``rstgen.py``
4. Créer le répertoire de travail de reStructWeb
5. Donner les bonnes permissions au répertoire (l'utilisateur
   de apache doit pouvoir modifier et créer des fichiers dans ce
   répertoire)
6. Copier les fichiers de templates dans le répertoire de travail :
   ``default.tmpl.fr``, ``default.tmpl.en``
7. Tester

Mode redirection par Apache
---------------------------

Procéder comme pour le mode standalone et configurer Apache de la
manière suivante : ::

  Script GET /cgi-bin/rstgen.py
  Script POST /cgi-bin/rstgen.py
  ErrorDocument 404 /cgi-bin/rstgen.py

Ma configuration
----------------

Sur ma machine, le répertoire de travail est ``/home/web/david/pages``,
le script ``rstgen.py`` est copié dans le répertoire ``/home/web/david/cgi-bin``.

Voici ma configuration complète: ::

  <Directory "/home/web/david/pages">
        Options FollowSymLinks MultiViews +Includes
        Script GET /drobert/admin
        Script POST /drobert/admin
        ErrorDocument 404 /drobert/admin
        AddDefaultCharset UTF-8
  </Directory>
 
  <Directory "/home/web/david/pages/st">
        Options Indexes FollowSymLinks MultiViews +Includes
        AddDefaultCharset ISO-8859-1
  </Directory>

  <VirtualHost *>
    ServerAdmin webmaster@ombrepixel.com

    DocumentRoot /var/www/ombrepixel.com
    ServerName www.ombrepixel.com
    ServerAlias ombrepixel.com
    ErrorLog logs/www.ombrepixel.com-error_log
    CustomLog logs/www.ombrepixel.com-access_log combined
    ScriptAlias /drobert/admin /home/web/david/cgi-bin/rstgen.py
    Alias /drobert /home/web/david/pages/
  </VirtualHost>

Templates
---------

Intéret
~~~~~~~

L'apparance de chaque page peut être totalement personnalisée car le système 
utilise le principe des templates. Ne vous fiez pas à la pauvreté graphique de
ce site. Il est tout à fait possible de faire un site vraiment beau en utilisant
reStructWeb.

Les templates sont des fichiers à l'extension ``.tmpl`` situés dans le répertoire
de travail. Il existe au minimun un fichier de template par défaut et par
langue, ainsi, sur mon site, deux fichiers sont présents sur le répertoire de
travail :

* ``default.tmpl.fr``
* ``default.tmpl.en``

Ils correspondent aux templates par défaut pour toutes les pages, en français
et en anglais.

Vous pouvez créer des templates spécifiques à chaque page de la forme
``nom_page.tmpl.fr``. Par exemple si je veux un template particulier pour la
page reStructWeb, il suffit de créer les fichiers ``restructweb.tmpl.fr`` et
``restructweb.tmpl.en``.

Balises
~~~~~~~

Le fichier template est un fichier html complet dans lequel un certain nombre
de balises sont remplacées par du contenu dynamique. Actuellement, reStructWeb
permet d'utiliser les balises suivantes :

+-------------------+---------------------------------+
| Balise            | Est remplacée par               |
+===================+=================================+
| ``$title``        | Titre [#]_ de la page           |
+-------------------+---------------------------------+
| ``$body``         | Corp de la page                 |
+-------------------+---------------------------------+
| ``$sourceUrl``    | URL page source                 |
+-------------------+---------------------------------+
| ``$editUrl``      | URL d'édition de la page        |
+-------------------+---------------------------------+
| ``$enUrl``        | URL de la version anglaise      |
+-------------------+---------------------------------+
| ``$frUrl``        | URL de la version française     |
+-------------------+---------------------------------+
| ``$lastModified`` | Date de dernière modification   |
+-------------------+---------------------------------+

.. [#] Le titre de la page en reStructuredText_ correspond au titre de première 
       section

Bugs / A faire
==============

* J'ai remarqué que sous IE en faisant
  http://www.ombrepixel.com/drobert/restructweb on arrive directement
  sur le document RST et non HTML
* Dictionnaire
* Faire une interprétation dynamique des balises d'url pour les autres langues

Autres projets
==============

* Ian Bicking reST wiki : http://wiki.webwareforpython.org/thiswiki

.. _Python: http://www.python.org/
.. _Wiki: http://c2.com/cgi/wiki?WikiWikiWeb
.. _RestructuredText: http://docutils.sourceforge.net/rst.html
.. _Python: http://www.python.org/
.. _Docutils: http://docutils.sourceforge.net/
.. _Apache: http://www.apache.org/
